#!/usr/bin/env python
#fileencoding: utf-8
#Author: Liu DongMiao <liudongmiao@gmail.com>
#Created  : Mon 05 Jul 2010 04:34:02 PM CST

''' Control LEDS '''

ERROR_LED = '/sys/class/leds/error'
FIRMWARE_LED = '/sys/class/leds/firmware'
SYSTEM_LED = '/sys/class/leds/system'
USBCOPY_LED = '/sys/class/leds/usbcopy'

OFF = 'none'
BLINK = 'timer'
ON = 'default-on'

import os
def control(led, state, on=0, off=0):
    def write(filename, content):
        if os.path.exists(filename):
            fd = os.open(filename, os.O_WRONLY)
            os.write(fd, content)
            os.close(fd)

    trigger = os.path.join(led, 'trigger')
    delay_on = os.path.join(led, 'delay_on')
    delay_off = os.path.join(led, 'delay_off')
    write(trigger, state)
    if state == BLINK:
        if isinstance(on, int) and on > 0:
            write(delay_on, str(on))
        if isinstance(on, int) and off > 0:
            write(delay_off, str(off))
    if led == ERROR_LED:
        control(FIRMWARE_LED, state, on, off)

# vim: set sta sw=4 et:
